package com.agiledeveloper;

import junit.framework.TestCase;

import java.io.IOException;

public class TestGuesser extends TestCase
{
    private Guesser _guesser;

    public TestGuesser(String s)
    {
        super(s);
    }

    protected void setUp() throws Exception
    {
        _guesser = new Guesser();
    }

    public void testTargetRange()
    {
        assertTrue(_guesser.target >= 0);
        assertTrue(_guesser.target <= 100);
    }

    public void testTargetIsRandom()
    {
        Guesser another = new Guesser();

        assertTrue(_guesser.target != another.target);
    }

    public void testGuessMatch()
    {
        assertEquals(0, _guesser.guess(_guesser.target));
    }

    public void testGuessLower()
    {
        assertEquals(-1, _guesser.guess(_guesser.target - 1));
        assertEquals(-1, _guesser.guess(_guesser.target - 2));
        assertEquals(-1, _guesser.guess(_guesser.target - 10));
        assertEquals(-1, _guesser.guess(- 1));
    }

    public void testGuessHigher()
    {
        assertEquals(1, _guesser.guess(_guesser.target + 1));
        assertEquals(1, _guesser.guess(_guesser.target + 2));
        assertEquals(1, _guesser.guess(_guesser.target + 10));
        assertEquals(1, _guesser.guess(101));
    }

    public void testNumberofAttempts()
    {
        assertEquals(0, _guesser.getAttempts());
        _guesser.guess(_guesser.target + 2);
        assertEquals(1, _guesser.getAttempts());
        _guesser.guess(_guesser.target - 5);
        assertEquals(2, _guesser.getAttempts());
        _guesser.guess(_guesser.target + 10);
        assertEquals(3, _guesser.getAttempts());
        _guesser.guess(_guesser.target);
        assertEquals(4, _guesser.getAttempts());
    }

    public void testAttemptsNotCountedAfterWin()
    {
        assertEquals(0, _guesser.getAttempts());
        _guesser.guess(_guesser.target + 2);
        assertEquals(1, _guesser.getAttempts());
        _guesser.guess(_guesser.target - 5);
        assertEquals(2, _guesser.getAttempts());
        _guesser.guess(_guesser.target);
        assertEquals(3, _guesser.getAttempts());
        _guesser.guess(_guesser.target);
        assertEquals(3, _guesser.getAttempts());
    }

    public void testFoo()
    {
        assertEquals(1, _guesser.foo());
    }

//    public void testDistance()
//    {
//        try
//        {
//            jdepend.framework.JDepend depend = new jdepend.framework.JDepend();
//            depend.addDirectory(".");
//            depend.analyze();
//
//            jdepend.framework.JavaPackage pkg = depend.getPackage("com.agiledeveloper");
//
//            assertEquals(0, pkg.distance(), 0.25); // Try this with 0.0025 instead of 0.25
//        }
//        catch (IOException e)
//        {
//            e.printStackTrace();
//        }
//    }
}
